//#include <usbdrv.h>
//#include <stddef.h>  // for NULL
//#include <avr/io.h>
//#include <avr/interrupt.h>
//#include "pt.h"
//#include "peri.h"
//#include "timer.h"

// นิยามมาโคร PT_DELAY ไว้เพื่อจำลองการหน่วงเวลาแบบมัลติทาสกิ้ง
//#define PT_DELAY(pt, ms, ts) \
//    ts = timer_millis(); \
 //   PT_WAIT_WHILE(pt, timer_millis()-ts < (ms));

const byte NONE = 0;
const byte LEFT = 1;
const byte UP = 2;
const byte RIGHT = 3;
const byte DOWN = 4;
const byte SELECT = 5;
const byte RED_BUTTON=1;
const byte GREEN_BUTTON=2;
const byte BLUE_BUTTON=3;
const byte keypadPin = PIN_PC0;
const byte test=PIN_PD3;
const int bz = PIN_PC4;
const byte SW_START = PIN_PB0;
const byte SW_VERIFY = PIN_PB1; 
unsigned long curmil;
byte key;
int last_time =0;
int redPin = PIN_PC1;
int greenPin = PIN_PC2;
int bluePin = PIN_PC3;
int red_led = PIN_PB2;
int green_led = PIN_PB3;
int blue_led = PIN_PB4;
int score,check; 
long randNumber;
int cond;
int sequence[3];
int ans[3];
int sum;
int count;
int r,b,g,st,timer,start,pretimer;
unsigned long cur ;
int sw_start,sw_verify;
int cs,cs4,cs5,cs6,ls;
unsigned long premil=0,premil2=0;
unsigned long timer_start=0;
int st_en=0;
//#define RQ_GET_SCORES  0
//#define RQ_GET_START  1
//#define RQ_GET_SWITCH  2

/*usbMsgLen_t usbFunctionSetup(uint8_t data[8])
{
  static uint8_t switch_state;
  static uint8_t switch_start;
  usbRequest_t *rq = (usbRequest_t*)data;

  if (rq->bRequest == RQ_GET_SCORES)
  {
    usbMsgPtr = (uint8_t*) &score;
    return sizeof(score);
  }
  else if (rq->bRequest == RQ_GET_START)
  {
    if(digitalRead(PIN_PB0)==LOW) 
      switch_start =1;
    else
      switch_start =0;
    usbMsgPtr = (uint8_t*) &switch_start;
    return sizeof(switch_start);
  }
  else if(rq->bRequest == RQ_GET_SWITCH)
  {
    if(digitalRead(PIN_PB1)==LOW) 
      switch_state =1;
    else
      switch_state =0;
    usbMsgPtr = (uint8_t*) &switch_state;
    return sizeof(switch_state);
  }
    return 0;  // return no data back to host
}*/

  
void setup()
{
  pinMode(keypadPin, INPUT_PULLUP);
  pinMode(redPin, OUTPUT);
  pinMode(greenPin, OUTPUT);
  pinMode(bluePin, OUTPUT); 
  pinMode(red_led, OUTPUT); 
  pinMode(green_led, OUTPUT); 
  pinMode(blue_led, OUTPUT); 
  pinMode(PIN_PD3,OUTPUT);
  pinMode(bz,OUTPUT);
  pinMode(SW_START,INPUT_PULLUP);
  pinMode(SW_VERIFY,INPUT_PULLUP);
  cs=0;score=0;check=0;r=0;g=0;b=0;sum=0;count=0;cs4=0;cs5=0;cs6=0;ls=0;
  //key=0;
  //noTone(bz);
 // usbInit();
  // usbDeviceDisconnect();
   //delay(300);
   //usbDeviceConnect();
}

void loop()
{

  curmil=millis();
  
  //usbPoll();
  
  if(cs==0){
    if(digitalRead(SW_START)==LOW && ls==0 && st_en==0){
      premil=curmil;
      st_en=1;
    }
    if(digitalRead(SW_START)==HIGH && ls==0 && st_en==1){
      premil=curmil;
      cs = 1;ls=1;st_en=0;
    }
  }
  
  if(cs==1) {
    if(curmil -premil >=500 && ls==1){
      randomLed(0);
      premil=curmil;
      ls=2;
    }
    if(curmil - premil >=500&& ls==2){
      setColor(0,0,0);
      premil=curmil;
      cs = 2;
      ls=3;
    }
    timer_se();
  }
  if(cs==2) {
    
    if(curmil -premil >=500&& ls==3){
      randomLed(1);
      premil=curmil;
      ls=4; 
    }
    if(curmil - premil >=500&& ls==4){
      setColor(0,0,0);
      premil=curmil;
      cs = 3;
      ls=5;
    }
    timer_se();
  }
  if(cs==3){
     
    if(curmil -premil >=500 && ls==5){
      randomLed(2);
      premil=curmil; 
      ls=6;
    }
    if(curmil - premil >=500 && ls==6){
      setColor(0,0,0);
      premil=curmil;
      cs = 4;
      ls=0;
    }
    timer_se();
  }
  if(cs==4){
    if(cs4==0){
      sum=0;count=0;r=0;g=0;b=0;cs4=1;
    }
    
    selectLed(0);
    timer_se();
  }
  if(cs==5){
    if(cs5==0){
      sum=0;count=0;r=0;g=0;b=0;cs5=1;
    }
    selectLed(1);
    timer_se();
  }
  if(cs==6){
    if(cs6==0){
      sum=0;count=0;r=0;g=0;b=0;cs6=1;
    }
    selectLed(2);
    timer_se();
  }
  if(cs==7){
    sw_verify = digitalRead(SW_VERIFY);
    if(sw_verify==0){
      if(check==3){
        score++;
        sound(1000,500);
        }
       else{
        sound(100,500);
       }
      check=0;cs4=0;cs5=0;cs6=0;cs=1;ls=1;
    }
    timer_se();
  }

 
}
void timer_se()
{
  if(digitalRead(SW_START)==LOW && st_en==0){
      st_en=1;
    }
    if(digitalRead(SW_START)==HIGH && st_en==1){
      cs=0;st_en=0;check=0;cs4=0;cs5=0;cs6=0;ls=0;setColor(0,0,0);writeLed(0,0,0); digitalWrite(bz,LOW);
    }
    
    
}
void sound(int f,int de)
{
  digitalWrite(bz,HIGH);
  tone(bz,f);delay(de);
  noTone(bz);
  digitalWrite(bz,LOW);
}
void Stop()
{
  cur = millis();
  setColor(255,255,255);
  digitalWrite(bz,HIGH);
  tone(bz,4000);
//  my_delay(300);
  tone(bz,3000);
  //my_delay(300);
  tone(bz,2000);
  //my_delay(300);
  noTone(bz);
  digitalWrite(bz,LOW);
  setColor(0,0,0);
  st=0;
}

void writeLed(int r,int b,int g)
{
  digitalWrite(red_led,r);
  digitalWrite(blue_led,b);
  digitalWrite(green_led,g);
}

void selectLed(int j)
{  
    if(curmil-premil2 >=50){
      key = getKey();
      if (key==LEFT) {digitalWrite(red_led,HIGH);r=1;}
      if (key==RIGHT) {digitalWrite(blue_led,HIGH);b=1;}
      if (key==UP) {digitalWrite(green_led,HIGH);g=1;}
      if (key==DOWN) {digitalWrite(red_led,LOW);
                digitalWrite(blue_led,LOW);
                digitalWrite(green_led,LOW);r=0;b=0;g=0;}//pur=r b , yel=r g, aq= g b
      if(curmil-premil >=150){
        if(key==SELECT){
          if(r==1){sum+=RED_BUTTON;count+=1;}
          if(b==1){sum+=BLUE_BUTTON;count+=1;}
          if(g==1){sum+=GREEN_BUTTON;count+=1;}
          writeLed(0,0,0);
          //delay(10);
          if(count>1) ans[j]=sum+1;
          if(count==1)ans[j]=sum;
          sound(2500,100);
          if(ans[j]==sequence[j]){check+=1;}     
          key = getKey(); 
          cs++;
        }
        premil=curmil;
      }
      premil2=curmil;
    }
}

void randomLed(int i)
{   
    unsigned long seed=seedOut(31);
    randomSeed(seed);
    randNumber = random(1,7);   
    sequence[i] = randNumber; 
    if(sequence[i]==1) setColor(255, 0, 0);//red
    if(sequence[i]==2) setColor(0, 255, 0);//green
    if(sequence[i]==3) setColor(0, 0, 255); //blue
    if(sequence[i]==4) setColor(255, 255, 0);//yellow
    if(sequence[i]==5) setColor(255, 0, 255);//purple
    if(sequence[i]==6) setColor(0, 255, 255);//aqua
}
 
void setColor(int red, int green, int blue)
{
  #ifdef COMMON_ANODE
    red = 255 - red;
    green = 255 - green;
    blue = 255 - blue;
  #endif
  analogWrite(redPin, red);
  analogWrite(greenPin, green);
  analogWrite(bluePin, blue);  
}
int getKey()
{
int val = 0;
int button = 0;
val = analogRead(keypadPin);
button = NONE;
if (val <=20) { button = LEFT; }
else if ((val >=20) && (val <100)){button = UP; }
else if ((val >=100) && (val <150)){button = DOWN; }
else if ((val >=150) && (val <300)){button = RIGHT; }
else if ((val >=300) && (val<500)){button = SELECT; }
return button;
}

//random rgb led
unsigned int bitOut(void)
{
  static unsigned long firstTime=1, prev=0;
  unsigned long bit1=0, bit0=0, x=0, port=0, limit=99;
  if (firstTime)
  {
    firstTime=0;
    prev=analogRead(port);
  }
  while (limit--)
  {
    x=analogRead(port);
    bit1=(prev!=x?1:0);
    prev=x;
    x=analogRead(port);
    bit0=(prev!=x?1:0);
    prev=x;
    if (bit1!=bit0)
      break;
  }
  return bit1;
}

unsigned long seedOut(unsigned int noOfBits)
{
  // return value with 'noOfBits' random bits set
  unsigned long seed=0;
  for (int i=0;i<noOfBits;++i)
    seed = (seed<<1) | bitOut();
  return seed;
}
